using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_Maestros._0_Modelos;
using Exferia_Aplicacion.Modelos_MantenimientoAgrupacionesCabecera;
using System.Data.SqlClient;
using System.Transactions;
using Exferia_Maestros.General;
using System.Threading;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Maestros._1_Datos
{
    public class MAE_AgrupacionesArticulosLineas_Datos : ABS_Datos
    {
        #region Listado
        private List<INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo> g_lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_AgrupacionesArticulosLineas).Name), _lst_CamposConRelacionABuscar, -1,null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo != null) && (g_lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.Count() > 0))
                {
                    lst_MAE = g_lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_AgrupacionesArticulosLineas_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_MAE;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_AgrupacionesArticulosLineas).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo != null) && (g_lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.Count() > 0))
                {
                    dnm_MAE = g_lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_AgrupacionesArticulosLineas_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MAE;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
           try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtros_Empresas = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idEmpresasRelacionadas);

                //Filtros de Opciones ..............................................
                long lng_Padre_id = -1;
                string str_Padre_Opcion = "";

                long lng_Padre_id_AgrupacionCabecera = -1;
                string str_Padre_Opcion_AgrupacionCabecera = "";

                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    foreach (INTERNO_Filtro_OpcionPadre_Modelo mdl_INTERNO_Filtro_OpcionPadre_Modelo in _lst_INTERNO_Filtro_OpcionPadre_Modelo)
                    {
                        //AGRUPACION ARTICULO CABECERA
                        if (mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO.Equals(Variables.G_STR_OPCION_MAE_AGRUPACIONARTICULOCABECERA))
                        {
                            lng_Padre_id_AgrupacionCabecera = mdl_INTERNO_Filtro_OpcionPadre_Modelo.VALOR;
                            str_Padre_Opcion_AgrupacionCabecera = mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO;
                        }
                        else
                        {
                            lng_Padre_id = mdl_INTERNO_Filtro_OpcionPadre_Modelo.VALOR;
                            str_Padre_Opcion = mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO;
                        }
                    }
                }
                //...................................................................

                string str_SQL =
                   " SELECT DISTINCT " +
                           nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.id) + " = " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.id) + "," +
                           nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.codigo) + " = " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.codigo) + "," +
                           nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.descripcion) + " = " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.descripcion) + "," +
                           nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.fechaBorrado) + " = " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.fechaBorrado) + "," +
                           //ids
                           nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.idAgrupacionCabecera) + " = " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.idAgrupacionArticuloCabecera) + "," +
                           //AgrupacionCabecera
                           nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.Cabecera_Codigo) + " = " + nameof(MAE_AgrupacionesArticulosCabeceras) + "." + nameof(MAE_AgrupacionesArticulosCabeceras.codigo) + "," +
                           nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.Cabecera_Descripcion) + " =" + nameof(MAE_AgrupacionesArticulosCabeceras) + "." + nameof(MAE_AgrupacionesArticulosCabeceras.descripcion) + "," +
                           nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.Cabecera_FechaBorrado) + " =" + nameof(MAE_AgrupacionesArticulosCabeceras) + "." + nameof(MAE_AgrupacionesArticulosCabeceras.fechaBorrado) +
                        " FROM " + nameof(MAE_AgrupacionesArticulosLineas) +
                        //AgrupacionCabecera
                        " LEFT JOIN " + nameof(MAE_AgrupacionesArticulosCabeceras) + " ON " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.idAgrupacionArticuloCabecera) + " = " + nameof(MAE_AgrupacionesArticulosCabeceras) + "." + nameof(MAE_AgrupacionesArticulosCabeceras.id) +
                        " WHERE " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.fechaBorrado) + " IS NULL AND " +
                                       //Cliente,Proveedor
                                       (
                                            (lng_Padre_id > -1)
                                            ?
                                            (nameof(MAE_AgrupacionesArticulosCabeceras) + "." + (nameof(MAE_AgrupacionesArticulosCabeceras.clienteProveedor) + "=@lng_Padre_id") +
                                             " OR " + nameof(MAE_AgrupacionesArticulosCabeceras) + "." + (nameof(MAE_AgrupacionesArticulosCabeceras.clienteProveedor) + "=" + Variables.G_INT_TIPOCLIENTEPROVEEDOR_TODOS_CODIGO))
                                            : ("1 = 1")
                                       )
                                       + " AND " +
                                       //Agrupacion articulo cabecera
                                       (
                                            (lng_Padre_id_AgrupacionCabecera > -1)
                                            ? (nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.idAgrupacionArticuloCabecera) + "=@lng_Padre_id_AgrupacionCabecera")
                                            : ("1 = 1")
                                       )
                                       + " AND (" +
                                              nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.idEmpresa) + "=@idEmpresa" +
                                             (
                                                 (_lst_idEmpresasRelacionadas != null && _lst_idEmpresasRelacionadas.Count > 0)
                                                     ? (" OR " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.idEmpresa) + " in (" + str_Filtros_Empresas + ") ")
                                                     : " "
                                             ) +
                                       " ) AND " +
                                       ( 
                                          (_lng_id > -1 )
                                          ? (nameof(MAE_AgrupacionesArticulosLineas) + "." + (nameof(MAE_AgrupacionesArticulosLineas.id) + "=@id"))
                                          : ("1 = 1")
                                       )
                                       + " AND " +
                                       nameof(MAE_AgrupacionesArticulosCabeceras) + "." + nameof(MAE_AgrupacionesArticulosCabeceras.fechaBorrado) + " IS NULL ";

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresaSeleccionada));
                lst_Parametros.Add(new SqlParameter("@lng_Padre_id", lng_Padre_id));
                lst_Parametros.Add(new SqlParameter("@id", _lng_id));
                lst_Parametros.Add(new SqlParameter("@lng_Padre_id_AgrupacionCabecera", lng_Padre_id_AgrupacionCabecera));


                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                g_lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo>(str_SQL, arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_AgrupacionesArticulosLineas_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        private INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo g_mdl_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo_F3 = null;

        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_AgrupacionesArticulosLineas).Name), _str_CampoBusqueda, _str_filtro, -1, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo_F3 != null)
                {
                    dnm_MAE = g_mdl_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_AgrupacionesArticulosLineas_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MAE;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Conuslta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_AgrupacionesArticulosLineas).Name), "", "", _lng_id, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo_F3 != null)
                {
                    dnm_MAE = g_mdl_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_AgrupacionesArticulosLineas_Datos) + "/" + nameof(Obtener_F3_PorId), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MAE;
        }      
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtros_Empresas = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idEmpresasRelacionas);


                //Filtros de Opciones ..............................................
                long lng_Padre_id = -1;
                string str_Padre_Opcion = "";

                long lng_Padre_id_AgrupacionCabecera = -1;
                string str_Padre_Opcion_AgrupacionCabecera = "";

                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    foreach (INTERNO_Filtro_OpcionPadre_Modelo mdl_INTERNO_Filtro_OpcionPadre_Modelo in _lst_INTERNO_Filtro_OpcionPadre_Modelo)
                    {
                        //AGRUPACION ARTICULO CABECERA
                        if (mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO.Equals(Variables.G_STR_OPCION_MAE_AGRUPACIONARTICULOCABECERA))
                        {
                            lng_Padre_id_AgrupacionCabecera = mdl_INTERNO_Filtro_OpcionPadre_Modelo.VALOR;
                            str_Padre_Opcion_AgrupacionCabecera = mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO;
                        }
                        else
                        {
                            lng_Padre_id = mdl_INTERNO_Filtro_OpcionPadre_Modelo.VALOR;
                            str_Padre_Opcion = mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO;
                        }
                    }
                }
                //...................................................................

                string str_SQL =
                  " SELECT distinct " +
                      nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.id) + " = " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.id) + "," +
                      nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.codigo) + " = " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.codigo) + "," +
                      nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.descripcion) + " = " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.descripcion) + "," +
                      nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.fechaBorrado) + " = " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.fechaBorrado) +
              " FROM " + nameof(MAE_AgrupacionesArticulosLineas) +
              " LEFT JOIN " + nameof(MAE_AgrupacionesArticulosCabeceras) + " ON " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.idAgrupacionArticuloCabecera) + " = " + nameof(MAE_AgrupacionesArticulosCabeceras) + "." + nameof(MAE_AgrupacionesArticulosCabeceras.id) +
              " WHERE " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.fechaBorrado) + " IS null AND " +
                           nameof(MAE_AgrupacionesArticulosCabeceras) + "." + nameof(MAE_AgrupacionesArticulosCabeceras.fechaBorrado) + " IS null AND " +
                            //Cliente,Proveedor
                            (
                                (lng_Padre_id > -1)
                                ?
                                (nameof(MAE_AgrupacionesArticulosCabeceras) + "." + (nameof(MAE_AgrupacionesArticulosCabeceras.clienteProveedor) + "=@lng_Padre_id") +
                                    " OR " + nameof(MAE_AgrupacionesArticulosCabeceras) + "." + (nameof(MAE_AgrupacionesArticulosCabeceras.clienteProveedor) + "=" + Variables.G_INT_TIPOCLIENTEPROVEEDOR_TODOS_CODIGO))
                                : ("1 = 1")
                            )
                            + " AND " +
                            //Agrupacion articulo cabecera
                            (
                                (lng_Padre_id_AgrupacionCabecera > -1)
                                ? (nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.idAgrupacionArticuloCabecera) + "=@lng_Padre_id_AgrupacionCabecera")
                                : ("1 = 1")
                            )
                            + " AND " +
                          " ( " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.idEmpresa) + "=@idEmpresa" +
                                (
                                    (_lst_idEmpresasRelacionas != null && _lst_idEmpresasRelacionas.Count > 0)
                                        ? (" OR " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.idEmpresa) + " in (" + str_Filtros_Empresas + ") ")
                                        : " "
                                ) +
                          " ) AND " +
                            (
                                (_lng_id > -1)
                                    ? (nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.id) + " = " + _lng_id)
                                    : (
                                        //Filtrar por Codigo
                                        (_str_CampoBusqueda.Equals(nameof(MAE_AgrupacionesArticulosLineas.codigo)))
                                            ? (nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.codigo) + "=@Filtro")
                                            //Filtrar por Descripcion
                                            : (nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.descripcion) + "=@Filtro")
                                    )
                            );

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresaSeleccionada));
                lst_Parametros.Add(new SqlParameter("@lng_Padre_id", lng_Padre_id));
                lst_Parametros.Add(new SqlParameter("@lng_Padre_id_AgrupacionCabecera", lng_Padre_id_AgrupacionCabecera));
                lst_Parametros.Add(new SqlParameter("@Filtro", _str_Filtro));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                g_mdl_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo_F3 = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_AgrupacionesArticulosLineas_Datos) + "/" + nameof(ConsultaRellenar_F3), true);
            }
        }
        #endregion

        #region Obtener
        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 2;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                 " SELECT distinct " +
                     nameof(INTERNO_MantenimientoAgrupacionesLinea_Modelo.id) + " = " + nameof(MAE_AgrupacionesArticulosLineas.id) + "," +
                     nameof(INTERNO_MantenimientoAgrupacionesLinea_Modelo.codigo) + " = " + nameof(MAE_AgrupacionesArticulosLineas.codigo) + "," +
                     nameof(INTERNO_MantenimientoAgrupacionesLinea_Modelo.descripcion) + " = " + nameof(MAE_AgrupacionesArticulosLineas.descripcion) + "," +
                     nameof(INTERNO_MantenimientoAgrupacionesLinea_Modelo.idAgrupacionCabecera) + " = " + nameof(MAE_AgrupacionesArticulosLineas.idAgrupacionArticuloCabecera) + "," +
                     nameof(INTERNO_MantenimientoAgrupacionesLinea_Modelo.idEmpresa) + " = " + nameof(MAE_AgrupacionesArticulosLineas.idEmpresa) + "," +
                     nameof(INTERNO_MantenimientoAgrupacionesLinea_Modelo.fechaBorrado) + " = " + nameof(MAE_AgrupacionesArticulosLineas.fechaBorrado) +
                 " FROM " + nameof(MAE_AgrupacionesArticulosLineas) +
                 " WHERE " + nameof(MAE_AgrupacionesArticulosLineas.fechaBorrado) + " IS null AND " +
                             nameof(MAE_AgrupacionesArticulosLineas.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<INTERNO_MantenimientoAgrupacionesLinea_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //MAE_Articulos_AgrupacionesArticulosLineas ##########################################################################################
                    ThreadStart obj_ThreadStart_PROVEEDOR_AGRUPACIONESARTICULOSLINEAS = new ThreadStart(Obtener_Articulos_AgrupacionesArticulosLineas_Modelo_Obtener);
                    Thread obj_Thread_PROVEEDOR_AGRUPACIONESARTICULOSLINEAS = new Thread(obj_ThreadStart_PROVEEDOR_AGRUPACIONESARTICULOSLINEAS);
                    obj_Thread_PROVEEDOR_AGRUPACIONESARTICULOSLINEAS.Start();

                    //MAE_AgrupacionesArticulosLineasFotos ##########################################################################################
                    ThreadStart obj_ThreadStart_AGRUPACIONESARTICULOSLINEASFOTOS = new ThreadStart(Obtener_AgrupacionesArticulosLineas_Fotos_Modelo_Obtener);
                    Thread obj_Thread_AGRUPACIONESARTICULOSLINEASFOTOS = new Thread(obj_ThreadStart_AGRUPACIONESARTICULOSLINEASFOTOS);
                    obj_Thread_AGRUPACIONESARTICULOSLINEASFOTOS.Start();

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_AgrupacionesArticulosLineas_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }

        #region Tablas Relacionadas
        private void Obtener_Articulos_AgrupacionesArticulosLineas_Modelo_Obtener()
        {
            try
            {
                MAE_Articulos_AgrupacionesArticulosLineas_Datos obj_MAE_Articulos_AgrupacionesArticulosLineas_Datos = new MAE_Articulos_AgrupacionesArticulosLineas_Datos();
                g_dnm_Modelo_Obtener.Listado_Agrupados = obj_MAE_Articulos_AgrupacionesArticulosLineas_Datos.Obtener_Listado_idArticulo_PoridAGrupacionArticuloLinea(g_dnm_Modelo_Obtener.id);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        private void Obtener_AgrupacionesArticulosLineas_Fotos_Modelo_Obtener()
        {
            try
            {
                MAE_AgrupacionesArticulosLineasFotos_Datos obj_MAE_AgrupacionesArticulosLineasFotos_Datos = new MAE_AgrupacionesArticulosLineasFotos_Datos();
                g_dnm_Modelo_Obtener.Imagen_Modelo = obj_MAE_AgrupacionesArticulosLineasFotos_Datos.Obtener_FotoModelo_Por_IdAgrupacionArticuloLinea(g_dnm_Modelo_Obtener.id);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[1] = true;
            }
        }

        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }

        public List<INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo> Obtener_MAE_AgrupacionesArticulosLineas_PorCabecera(long _lng_idAgrupacionArticuloCabecera)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            List<INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo> lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
               " SELECT " +
                   nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.id) + " = " + nameof(MAE_AgrupacionesArticulosLineas.id) + "," +
                   nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.codigo) + " = " + nameof(MAE_AgrupacionesArticulosLineas.codigo) + "," +
                   nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.descripcion) + " = " + nameof(MAE_AgrupacionesArticulosLineas.descripcion) +
               " FROM " + nameof(MAE_AgrupacionesArticulosLineas) +
               " WHERE " + nameof(MAE_AgrupacionesArticulosLineas.fechaBorrado) + " IS null AND " +
                           nameof(MAE_AgrupacionesArticulosLineas.idAgrupacionArticuloCabecera) + "=@idAgrupacionArticuloCabecera ";
                //.......................................................................................

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idAgrupacionArticuloCabecera",  _lng_idAgrupacionArticuloCabecera)
                };

                //Rellenar el Modelo
                lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo = obj_Exferia_Entities.Database.SqlQuery<INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo>(str_SQL, arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_AgrupacionesArticulosLineas_Datos) + "/" + nameof(Obtener_MAE_AgrupacionesArticulosLineas_PorCabecera), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo;
        }
        
        public List<INTERNO_IDCodigoDescripcion_Modelo> Existen_Repetidos(List<long> _lst_idsAgrupacionesLineas_Actuales,long _lng_idAgrupacionLineaActual, List<long> _lst_idArticulo)
        {
            List<INTERNO_IDCodigoDescripcion_Modelo> lst_Articulos_Repetidos = new List<INTERNO_IDCodigoDescripcion_Modelo>();
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                //Articulo
                string str_Filtro_Articulos = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idArticulo);

                //AgrupacionLinea
                string str_Filtro_AgrupacionLinea = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idsAgrupacionesLineas_Actuales);

                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                      " SELECT " +
                          nameof(INTERNO_IDCodigoDescripcion_Modelo.Id) + " = " + nameof(MAE_Articulos) + "." + nameof(MAE_Articulos.id) + "," +
                          nameof(INTERNO_IDCodigoDescripcion_Modelo.Codigo) + " = " + nameof(MAE_Articulos) + "." + nameof(MAE_Articulos.codigo) + "," +
                          nameof(INTERNO_IDCodigoDescripcion_Modelo.Descripcion) + " = " + nameof(MAE_Articulos) + "." + nameof(MAE_Articulos.descripcion) +
                      " FROM " + nameof(MAE_Articulos_AgrupacionesArticulosLineas) +
                      " LEFT JOIN " + nameof(MAE_AgrupacionesArticulosLineas) + " ON " + nameof(MAE_Articulos_AgrupacionesArticulosLineas) + "." + nameof(MAE_Articulos_AgrupacionesArticulosLineas.idAgrupacionArticuloLinea) + " = " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.id) +
                      " LEFT JOIN " + nameof(MAE_Articulos) + " ON " + nameof(MAE_Articulos_AgrupacionesArticulosLineas) + "." + nameof(MAE_Articulos_AgrupacionesArticulosLineas.idArticulo) + " = " + nameof(MAE_Articulos) + "." + nameof(MAE_Articulos.id) +
                      " WHERE " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.fechaBorrado) + " IS null " +
                                (
                                    (_lst_idArticulo != null && _lst_idArticulo.Count > 0)
                                        ? (" AND " + nameof(MAE_Articulos_AgrupacionesArticulosLineas) + "." + nameof(MAE_Articulos_AgrupacionesArticulosLineas.idArticulo) + " in (" + str_Filtro_Articulos + ") ")
                                        : " "
                                ) +
                              " AND NOT " + nameof(MAE_Articulos_AgrupacionesArticulosLineas) + "." + nameof(MAE_Articulos_AgrupacionesArticulosLineas.idAgrupacionArticuloLinea) + "=@idAgrupacionArticuloLinea " +
                                (
                                    (_lst_idsAgrupacionesLineas_Actuales != null && _lst_idsAgrupacionesLineas_Actuales.Count > 0)
                                        ? (" AND " + nameof(MAE_Articulos_AgrupacionesArticulosLineas) + "." + nameof(MAE_Articulos_AgrupacionesArticulosLineas.idAgrupacionArticuloLinea) + " in (" + str_Filtro_AgrupacionLinea + ") ")
                                        : " "
                                );

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idAgrupacionArticuloLinea", _lng_idAgrupacionLineaActual));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                lst_Articulos_Repetidos = obj_Exferia_Entities.Database.SqlQuery<INTERNO_IDCodigoDescripcion_Modelo>(str_SQL, arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_AgrupacionesArticulosLineas_Datos) + "/" + nameof(Existen_Repetidos), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return lst_Articulos_Repetidos;
        }

        public List<long> Obtener_RegistroRepetidos(List<long> _lst_idsAgrupacionesLineas_Actuales, long _lng_idAgrupacionLineaActual)
        {
            List<long> lst_Repetidos = new List<long>();
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {

                List<SqlParameter> lst_Parametros = new List<SqlParameter>();
                //AgrupacionLinea

                string str_Filtro_AgrupacionLinea = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idsAgrupacionesLineas_Actuales);

                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                   " SELECT " +
                       nameof(MAE_Articulos) + "." + nameof(MAE_Articulos.id) +
                   " FROM " + nameof(MAE_Articulos_AgrupacionesArticulosLineas) +
                   " LEFT JOIN " + nameof(MAE_AgrupacionesArticulosLineas) + " ON " + nameof(MAE_Articulos_AgrupacionesArticulosLineas) + "." + nameof(MAE_Articulos_AgrupacionesArticulosLineas.idAgrupacionArticuloLinea) + " = " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.id) +
                   " LEFT JOIN " + nameof(MAE_Articulos) + " ON " + nameof(MAE_Articulos_AgrupacionesArticulosLineas) + "." + nameof(MAE_Articulos_AgrupacionesArticulosLineas.idArticulo) + " = " + nameof(MAE_Articulos) + "." + nameof(MAE_Articulos.id) +
                   " WHERE " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.fechaBorrado) + " IS null " +
                             (
                                 (_lst_idsAgrupacionesLineas_Actuales != null && _lst_idsAgrupacionesLineas_Actuales.Count > 0)
                                     ? (" AND " + nameof(MAE_Articulos_AgrupacionesArticulosLineas) + "." + nameof(MAE_Articulos_AgrupacionesArticulosLineas.idAgrupacionArticuloLinea) + " in (" + str_Filtro_AgrupacionLinea + ") ")
                                     : " "
                             ) +
                           " AND ( NOT " + nameof(MAE_Articulos_AgrupacionesArticulosLineas) + "." + nameof(MAE_Articulos_AgrupacionesArticulosLineas.idAgrupacionArticuloLinea) + "=@idAgrupacionProveedorLinea ) ";

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idAgrupacionProveedorLinea", _lng_idAgrupacionLineaActual));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                lst_Repetidos = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL, arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_AgrupacionesArticulosLineas_Datos) + "/" + nameof(Obtener_RegistroRepetidos), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return lst_Repetidos;
        }

        public List<long> Obtener_PorArticulo(long _lng_idArticulo, long _lng_idEmpresa, Exferia_Entities _obj_Exferia_Entities)
        {
            List<long> lst_Lineas_Por_Articulo = new List<long>();

            try
            {

                //Empresas relacionadas
                List<long> lst_idEmpresasrelacionadas = Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresa, typeof(MAE_AgrupacionesArticulosLineas).Name);
                string str_Filtro_Empresa = Funciones.Formar_ContenidoIN_ParaConsultaWhere(lst_idEmpresasrelacionadas);

                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_SQL =
                    " SELECT DISTINCT " +
                        nameof(MAE_Articulos_AgrupacionesArticulosLineas) + "." + nameof(MAE_Articulos_AgrupacionesArticulosLineas.idAgrupacionArticuloLinea) +
                    " FROM " + nameof(MAE_Articulos_AgrupacionesArticulosLineas) +
                    " LEFT JOIN " + nameof(MAE_AgrupacionesArticulosLineas) + " ON " + nameof(MAE_Articulos_AgrupacionesArticulosLineas) + "." + nameof(MAE_Articulos_AgrupacionesArticulosLineas.idAgrupacionArticuloLinea) + " = " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.id) +
                    " LEFT JOIN " + nameof(MAE_AgrupacionesArticulosCabeceras) + " ON " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.idAgrupacionArticuloCabecera) + " = " + nameof(MAE_AgrupacionesArticulosCabeceras) + "." + nameof(MAE_AgrupacionesArticulosCabeceras.id) +
                    " WHERE " + nameof(MAE_AgrupacionesArticulosCabeceras) + "." + nameof(MAE_AgrupacionesArticulosCabeceras.fechaBorrado) + " IS null AND " +
                                nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.fechaBorrado) + " IS null AND " +
                                nameof(MAE_Articulos_AgrupacionesArticulosLineas) + "." + nameof(MAE_Articulos_AgrupacionesArticulosLineas.idArticulo) + "=@idArticulo AND" +
                            " ( " + nameof(MAE_AgrupacionesArticulosCabeceras) + "." + nameof(MAE_AgrupacionesArticulosCabeceras.idEmpresa) + "=@idEmpresa" +
                                (
                                    (lst_idEmpresasrelacionadas != null && lst_idEmpresasrelacionadas.Count > 0)
                                        ? (" OR " + nameof(MAE_AgrupacionesArticulosCabeceras) + "." + nameof(MAE_AgrupacionesArticulosCabeceras.idEmpresa) + " in (" + str_Filtro_Empresa + ") ")
                                        : " "
                                ) +
                            " )";

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idArticulo", _lng_idArticulo));
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresa));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                lst_Lineas_Por_Articulo = _obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL, arr_Parametros).ToList();
            
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_AgrupacionesArticulosLineas_Datos) + "/" + nameof(Obtener_PorArticulo), true);
            }

            return lst_Lineas_Por_Articulo;
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private MAE_AgrupacionesArticulosLineas g_mdl_MAE_AgrupacionesArticulosLineas = null;
        public MAE_AgrupacionesArticulosLineas Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " + nameof(MAE_AgrupacionesArticulosLineas) + "." + nameof(MAE_AgrupacionesArticulosLineas.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_AgrupacionesArticulosLineas_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_MAE_AgrupacionesArticulosLineas;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                           object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_MAE_AgrupacionesArticulosLineas = obj_Exferia_Entities.Database.SqlQuery<MAE_AgrupacionesArticulosLineas>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_AgrupacionesArticulosLineas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #region Modelo Listado
        private List<MAE_AgrupacionesArticulosLineas> g_lst_MAE_AgrupacionesArticulosLineas = null;

        public List<MAE_AgrupacionesArticulosLineas> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids,
                                                                                   bool _bol_Cargar_AgrupacionesArticulosCabeceras)
        {
            try
            {
                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {
                    string str_Filtro_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(MAE_AgrupacionesArticulosLineas),
                                                                                            nameof(MAE_AgrupacionesArticulosLineas.id),
                                                                                            G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                            _lst_Ids);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                                " WHERE " +
                                                    str_Filtro_IDS;

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { },
                                                     _bol_Cargar_AgrupacionesArticulosCabeceras);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_AgrupacionesArticulosLineas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_MAE_AgrupacionesArticulosLineas;
        }

        #region Ejecutar Consulta
        //Listado de modelos Relacionados
        private List<MAE_AgrupacionesArticulosCabeceras> g_lst_MAE_AgrupacionesArticulosCabeceras = null;

        //Hilos
        private static int g_int_TotalHilos_Modelo_Listado = 1;
        private bool[] g_bol_Hilos_Terminados_Modelo_Listado = new bool[g_int_TotalHilos_Modelo_Listado];

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                    object[] _arr_Parametros,
                                                    bool _bol_Cargar_AgrupacionesArticulosCabeceras)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_MAE_AgrupacionesArticulosLineas = obj_Exferia_Entities.Database.SqlQuery<MAE_AgrupacionesArticulosLineas>(_str_SQL, _arr_Parametros).ToList();

                #region Rellenar tablas Relacionadas
                if (g_lst_MAE_AgrupacionesArticulosLineas != null && g_lst_MAE_AgrupacionesArticulosLineas.Count > 0)
                {
                    //Si tiene que buscar alguna tabla relacionada
                    if (_bol_Cargar_AgrupacionesArticulosCabeceras)
                    {
                        #region PRIMERO BUSCO LOS DATOS DE LAS TABLAS RELACIONADAS
                        //reiniciar Valores de los hilos
                        for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo_Listado; int_Contador++)
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[int_Contador] = false;
                        }

                        //MAE_AgrupacionesArticulosCabeceras #############################################
                        if (_bol_Cargar_AgrupacionesArticulosCabeceras)
                        {
                            ThreadStart obj_ThreadStart_AGRUPACIONARTICULOCABECERA = new ThreadStart(Obtener_AgrupacionArticuloCabecera_Modelo_Listado);
                            Thread obj_Thread_AGRUPACIONARTICULOCABECERA = new Thread(obj_ThreadStart_AGRUPACIONARTICULOCABECERA);
                            obj_Thread_AGRUPACIONARTICULOCABECERA.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
                        }

                        //Esperando a que terminen todos los hilos .........................................
                        bool bol_Termino = false;
                        while (bol_Termino == false)
                        {
                            bol_Termino = true;
                            foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo_Listado)
                            {
                                if (bol_Termino_Hilo == false)
                                {
                                    bol_Termino = false;
                                    break;
                                }
                            }

                            Thread.Sleep(10);
                        }
                        //.................................................................................
                        #endregion

                        #region DESPUES SE LO VOY ASIGNANDO A LOS REGISTRO UNO A UNO
                        foreach (MAE_AgrupacionesArticulosLineas mdl_MAE_AgrupacionesArticulosLineas in g_lst_MAE_AgrupacionesArticulosLineas)
                        {
                            //MAE_AgrupacionesArticulosCabeceras #############################################
                            if (_bol_Cargar_AgrupacionesArticulosCabeceras &&
                                g_lst_MAE_AgrupacionesArticulosCabeceras != null &&
                                g_lst_MAE_AgrupacionesArticulosCabeceras.Count > 0)
                            {
                                mdl_MAE_AgrupacionesArticulosLineas.MAE_AgrupacionesArticulosCabeceras = g_lst_MAE_AgrupacionesArticulosCabeceras.Where(m => m.id == mdl_MAE_AgrupacionesArticulosLineas.idAgrupacionArticuloCabecera).FirstOrDefault();
                            }
                        }
                        #endregion
                    }
                    
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_AgrupacionesArticulosLineas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #region Tablas relacionadas
        private void Obtener_AgrupacionArticuloCabecera_Modelo_Listado()
        {
            try
            {
                MAE_AgrupacionesArticulosCabeceras_Datos obj_MAE_AgrupacionesArticulosCabeceras_Datos = new MAE_AgrupacionesArticulosCabeceras_Datos();
                g_lst_MAE_AgrupacionesArticulosCabeceras = obj_MAE_AgrupacionesArticulosCabeceras_Datos.Obtener_ModeloListado_Por_Ids(g_lst_MAE_AgrupacionesArticulosLineas.Select(m => m.idAgrupacionArticuloCabecera).ToList());
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
            }
        }
        #endregion

        #endregion
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
               " SELECT " +
                   nameof(MAE_AgrupacionesArticulosLineas.id) + " , " +
                   nameof(MAE_AgrupacionesArticulosLineas.codigo) + " , " +
                   nameof(MAE_AgrupacionesArticulosLineas.descripcion) + " , " +
                   nameof(MAE_AgrupacionesArticulosLineas.idAgrupacionArticuloCabecera) + " , " +
                   nameof(MAE_AgrupacionesArticulosLineas.idEmpresa) + " , " +
                   nameof(MAE_AgrupacionesArticulosLineas.fechaBorrado) +
               " FROM " + nameof(MAE_AgrupacionesArticulosLineas);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();

                INTERNO_MantenimientoAgrupacionesLinea_Modelo mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo_AGrabar = (INTERNO_MantenimientoAgrupacionesLinea_Modelo)_mdl_obj;

                //Articulos relacionados
                List<long> lst_ids_Articulos = mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo_AGrabar.Listado_Agrupados.ToList();
                MAE_AgrupacionesArticulosLineas mdl_MAE_AgrupacionesArticulosLineas_DatosViejos = new MAE_AgrupacionesArticulosLineas();

                // Ver si existe ######################################################################
                MAE_AgrupacionesArticulosLineas mdl_MAE_AgrupacionesArticulosLineas_Final = Obtener_Modelo_Por_Id(mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo_AGrabar.id);
                //######################################################################################

                //UPDATE
                if (mdl_MAE_AgrupacionesArticulosLineas_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_AgrupacionesArticulosLineas_Final, mdl_MAE_AgrupacionesArticulosLineas_DatosViejos, false, false);

                    //Copio las propiedades sin relaciones
                    Cargar_DatosModelo(mdl_MAE_AgrupacionesArticulosLineas_Final, mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo_AGrabar);

                    #region UPDATE
                    string str_SQL_Update = " UPDATE " + nameof(MAE_AgrupacionesArticulosLineas) +
                                          " SET " +
                                              nameof(MAE_AgrupacionesArticulosLineas.codigo) + "=@codigo," +
                                              nameof(MAE_AgrupacionesArticulosLineas.descripcion) + "=@descripcion," +
                                              nameof(MAE_AgrupacionesArticulosLineas.idEmpresa) + "=@idEmpresa," +
                                              nameof(MAE_AgrupacionesArticulosLineas.idAgrupacionArticuloCabecera) + "=@idAgrupacionArticuloCabecera," +
                                              nameof(MAE_AgrupacionesArticulosLineas.fechaBorrado) + "=@fechaBorrado " +
                                          " WHERE " +
                                              nameof(MAE_AgrupacionesArticulosLineas.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_MAE_AgrupacionesArticulosLineas_Final.codigo),
                        new SqlParameter("@descripcion",  mdl_MAE_AgrupacionesArticulosLineas_Final.descripcion),
                        new SqlParameter("@idAgrupacionArticuloCabecera",  mdl_MAE_AgrupacionesArticulosLineas_Final.idAgrupacionArticuloCabecera),
                        new SqlParameter("@idEmpresa",  mdl_MAE_AgrupacionesArticulosLineas_Final.idEmpresa),
                        mdl_MAE_AgrupacionesArticulosLineas_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_MAE_AgrupacionesArticulosLineas_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        new SqlParameter("@id",  mdl_MAE_AgrupacionesArticulosLineas_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_ValorDevuelto_Modelo.Id = mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo_AGrabar.id;
                }
                //INSERT
                else
                {
                    mdl_MAE_AgrupacionesArticulosLineas_Final = new MAE_AgrupacionesArticulosLineas();

                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos del Modelo
                    Cargar_DatosModelo(mdl_MAE_AgrupacionesArticulosLineas_Final, mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo_AGrabar);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(MAE_AgrupacionesArticulosLineas) +
                                               " (" +
                                                       nameof(MAE_AgrupacionesArticulosLineas.codigo) + "," +
                                                       nameof(MAE_AgrupacionesArticulosLineas.descripcion) + "," +
                                                       nameof(MAE_AgrupacionesArticulosLineas.idAgrupacionArticuloCabecera) + "," +
                                                       nameof(MAE_AgrupacionesArticulosLineas.idEmpresa) + "," +
                                                       nameof(MAE_AgrupacionesArticulosLineas.fechaBorrado) +
                                               " ) " +
                                               " OUTPUT INSERTED." + nameof(MAE_TiposGastos.id) +
                                               " VALUES " +
                                               " ( " +
                                                   "@codigo," +
                                                   "@descripcion," +
                                                   "@idAgrupacionArticuloCabecera," +
                                                   "@idEmpresa," +
                                                   "@fechaBorrado" +
                                               " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_MAE_AgrupacionesArticulosLineas_Final.codigo),
                        new SqlParameter("@descripcion",  mdl_MAE_AgrupacionesArticulosLineas_Final.descripcion),
                        new SqlParameter("@idAgrupacionArticuloCabecera",  mdl_MAE_AgrupacionesArticulosLineas_Final.idAgrupacionArticuloCabecera),
                        new SqlParameter("@idEmpresa",  mdl_MAE_AgrupacionesArticulosLineas_Final.idEmpresa),
                        mdl_MAE_AgrupacionesArticulosLineas_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_MAE_AgrupacionesArticulosLineas_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                //Borrar Relaciones Antiguas ..............................................
                string str_SQL_Borrar = " DELETE FROM " + nameof(MAE_Articulos_AgrupacionesArticulosLineas) + " WHERE " + nameof(MAE_Articulos_AgrupacionesArticulosLineas.idAgrupacionArticuloLinea) + "=" + mdl_ValorDevuelto_Modelo.Id;
                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Borrar);
                //.........................................................................

                //Grabar Relaciones Nuevas .................................................
                if (lst_ids_Articulos != null && lst_ids_Articulos.Count > 0)
                {
                    string str_SQL_Insertar = "";
                    foreach (long lng_id in lst_ids_Articulos)
                    {
                        str_SQL_Insertar += " INSERT INTO " + nameof(MAE_Articulos_AgrupacionesArticulosLineas) + " (" + nameof(MAE_Articulos_AgrupacionesArticulosLineas.idArticulo) + "," + nameof(MAE_Articulos_AgrupacionesArticulosLineas.idAgrupacionArticuloLinea) + "," + nameof(MAE_Articulos_AgrupacionesArticulosLineas.observaciones) + ") values (" + lng_id + "," + mdl_ValorDevuelto_Modelo.Id + ",'')";
                    }

                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Insertar);
                }
                //.........................................................................
              
                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(MAE_AgrupacionesArticulosLineas), mdl_MAE_AgrupacionesArticulosLineas_DatosViejos, mdl_MAE_AgrupacionesArticulosLineas_Final, mdl_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_AgrupacionesArticulosLineas_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        private void Cargar_DatosModelo(MAE_AgrupacionesArticulosLineas _mdl_MAE_AgrupacionesArticulosLineas, INTERNO_MantenimientoAgrupacionesLinea_Modelo _mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo)
        {
            // Cargar los Datos Nuevos del Modelo
            _mdl_MAE_AgrupacionesArticulosLineas.id = _mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo.id;
            _mdl_MAE_AgrupacionesArticulosLineas.codigo = _mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo.codigo;
            _mdl_MAE_AgrupacionesArticulosLineas.descripcion = _mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo.descripcion;
            _mdl_MAE_AgrupacionesArticulosLineas.idEmpresa = _mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo.idEmpresa;
            _mdl_MAE_AgrupacionesArticulosLineas.idAgrupacionArticuloCabecera = _mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo.idAgrupacionCabecera;
            _mdl_MAE_AgrupacionesArticulosLineas.fechaBorrado = _mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo.fechaBorrado;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;
            
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                MAE_AgrupacionesArticulosLineas mdl_MAE_AgrupacionesArticulosLineas_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_MAE_AgrupacionesArticulosLineas_Final != null)
                {
                    #region UPDATE
                    string str_SQL_Update = " UPDATE " + nameof(MAE_AgrupacionesArticulosLineas) +
                                                " SET " +
                                                nameof(MAE_AgrupacionesArticulosLineas.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(MAE_AgrupacionesArticulosLineas.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@fechaBorrado",  DateTime.Now),
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(MAE_AgrupacionesArticulosLineas), null, mdl_MAE_AgrupacionesArticulosLineas_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                //Devolver tambien el Objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id;

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_AgrupacionesArticulosLineas_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                List<long> lst_idAgrupacionesLineas = (List<long>)_mdl_obj;

                if (lst_idAgrupacionesLineas != null && lst_idAgrupacionesLineas.Count > 0)
                {
                    //Coger los ids y ponerlos de forma que sirva para la consulta
                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(lst_idAgrupacionesLineas);

                    string str_SQL = " DELETE FROM " + nameof(MAE_AgrupacionesArticulosLineas) +
                                     " WHERE " + nameof(MAE_AgrupacionesArticulosLineas.id) + " in (" + str_Filtros_IDS + ")";

                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_AgrupacionesArticulosLineas_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion

    }
}
